/* make ghoul, which has grown into a generic make monster! :-) */
/* alan glover 11/Aug/93 (c), distribution rights reserved */
/* the boring bit....
    copyright retained (c)1993 Alan Glover. This is not PD.
  
    Permission is granted to spread this source, and the resultant
    executable freely providing that the source remains unchanged other
    than essential alterations for different flavours of C compiler.
   
    You may not charge for its distribution.
   
    It should compile cleanly under any ANSI C compiler.
  
    If you have ideas for changes, or implement any changes, please
    get in touch with me (alan@pinesoft.demon.co.uk) so that changes
    can be merged with the master source. Do not modify and distribute
    this program without consulting me first!
    
    Call of Cthulhu is a trademark of Chaosium Inc.
    For a catalogue call US (510)547-7681, or ftp as /pub/chaosium/info/catalog
    from soda.berkeley.edu (128.32.149.19)
    
    My thanks to Chaosium Inc. for permitting the use of data from
    the 5th Edition rule book, on the condition that no profit is
    made from this program.
*/    

/* 11/08/93  Written
   11/08/93  Change hp and damage bonus to be calculated from stats
   12/08/93  Change dice stats from int,int,int to char and add parser
   28/09/93  Tidy up for first source release
   28/09/93  Make sure it compiles for MicroSoft C 5.1. Changes:
             - stop using tolower(*out++) cos MS do it with a macro
               and the increment happens twice!
   01/10/93  More subtle changes ready for first release on soda.berkeley.edu
             Allow monster names to be abbreviated
   12/10/93  Received a request for more mundane creatures. Add all races
               from 5th Ed Beasts & Monsters section
 */   

#include <stdio.h>
#include <stdlib.h>
#include "time.h"
#include "ctype.h"
#include "string.h"

char my_tolower(char c)
{
  /* Microsoft C 5.1 implements this as a macro, which stops me using
     neat tricks like tolower(*in++). This lets me use them again :-). 
     Yes, I could try undefining the macro, in case there is a macro,
     but this solution is among the most platform & compile independent.
   */
  return tolower(c);
}

void banner(void)
{
  printf("Monster Maker 1.01 by Alan Glover. (C) 1993 Alan Glover\n");
  printf("for Call of Cthulhu (tm) 5th Edition\n\n"); 
  
  printf("For support, fixes, or changes email alan@pinesoft.demon.co.uk\n\n");

  printf("Call of Cthulhu is a trademark of Chaosium Inc.\n");
  printf("For a catalogue call US (510)547-7681, or ftp as /pub/chaosium/info/catalog\n");
  printf("from soda.berkeley.edu (128.32.149.19)\n");
  printf("\n");                        
}

void writedb(int nd,int dv)
{
   printf("Damage Bonus: %dd%d \n\n",nd,dv);
}

/***********************************/
/* Calculate & Output Damage bonus */
/***********************************/
void damage_bonus(int db)
{     
  if (db<=12) {writedb(-1,6);}
  else if (db>=13 & db<=16) {writedb(-1,4);}
  else if (db>=17 & db<=24) {writedb(0,0);}
  else if (db>=25 & db<=32) {writedb(1,4);}
  else if (db>=33) {writedb((db-33)/16+1,6);}
}


/* dice expression structure */
                           
struct monster { char* str; char* con; char* siz;\
                 char* inte; char* pow; char* dex;\
                 char* move; char *name;};

/*str       con          siz          int      pow      dex       mov  name */
struct monster monster_array[] = {
  "2d4",    "2d6",       "2d4",       "0",     "2d6",   "1d6+18", "1/12", "Bat",   
  "3d6+10", "2d6+6",     "3d6+10",    "0",     "3d6",   "3d6",    "16", "BlackBear",
  "2d6",    "3d6",       "1d4",       "0",     "2d6",   "2d6+12", "12", "BobCat",   
  "10d6+10","4d6+12",    "10d6+10",   "2d6+12","10d6",  "3d6+6",  "10/16", "Bunyip",
  "2d6+4",  "2d6+6",     "2d6+4",     "0",     "2d6",   "2d6",    "10", "BushPig",
  "5d6",    "3d6",       "5d6",       "3d6",   "3d6",   "3d6+3",  "5/20", "Byakhee",
  "4d6+20", "3d6+10",    "4d6+20",    "0",     "2d6",   "2d6",    "12", "CapeBuffalo",
  "3d6",    "3d6+10",    "3d6",       "5d6",   "1d6",   "2d6",    "6/1", "Chthonian1",
  "6d6",    "3d6+15",    "6d6",       "5d6",   "2d6",   "2d6",    "6/1", "Chthonian2",
  "9d6",    "3d6+20",    "9d6",       "5d6",   "3d6",   "2d6",    "6/1", "Chthonian3",
  "12d6",   "3d6+25",    "12d6",      "5d6",   "4d6",   "2d6",    "6/1", "Chthonian",
  "1d6",    "10d6",      "2d6",       "4d6",   "2d6",   "2d6+12", "12/20", "Colour",     
  "3d6+12", "3d6",       "3d6+6",     "0",     "2d6+6", "2d6+12", "5/12", "Condor",
  "4d6+12", "3d6+8",     "4d6+12",    "0",     "3d6",   "2d6",    "6/8", "Crocodile",
  "4d6+3",  "3d6+3",     "4d6+30",    "4d6",   "5d6",   "3d6+6",  "8", "DarkYoung",
  "4d6",    "3d6",       "3d6+30",    "2d6+6", "3d6",   "3d6",    "8/10", "DeepOne",
  "10d100", "1d100+100", "1d100+500", "2d6",   "10d6",  "1d4",    "18/10", "Dhole",    
  "2d6",    "3d6",       "1d6+1",     "0",     "2d6",   "2d6+6",  "12", "Dog",
  "4d6+24", "3d6+12",    "8d6",       "1d6+12","3d6",   "3d6+6",  "8/10", "ElderThing", 
  "6d6+34", "3d6+16",    "6d6+42",    "0",     "2d6+6", "3d6",    "10", "Elephant",
  "0",      "2d6",       "1",         "3d6",   "2d6+6", "3d6+6",  "11", "FireVampire",
  "4d6+36", "2d6+18",    "4d6+36",    "4d6",   "3d6+6", "2d6+6",  "8/12", "FlyingPolyp",
  "1d6+6",  "3d6",       "1d6+12",    "2d6+6", "3d6",   "2d6+12", "12", "FormlessSpawn1",
  "6d6+6",  "3d6",       "6d6+12",    "2d6+6", "3d6",   "2d6+12", "12", "FormlessSpawn6",
  "3d6+1",  "4d6",       "4d6+12",    "1d6",   "3d6",   "2d6+6",  "10", "Ghast",
  "3d6+6",  "2d6+6",     "2d6+6",     "2d6+6", "2d6+6", "2d6+6",  "9", "Ghoul",          
  "2d6+24", "3d6+12",    "2d6+24",    "1d6+12","6d6",   "4d6",    "9", "Gnoph-Keh", 
  "4d6+12", "3d6",       "2d6+12",    "1d6+1", "3d6",   "3d6",    "8", "Gorilla",
  "12d6",   "4d6+12",    "8d6+36",    "4d6+6", "2d6+6", "2d6+3",  "7", "GreatRaceOld",
  "1d2",    "1d3",       "1",         "2d6+6", "5d6+6", "2d6+6",  "4/10", "GreatRaceNew",
  "6d6+24", "3d6+18",    "6d6+36",    "2d6+6", "3d6",   "3d6",    "10", "Gug",    
  "3d6+18", "2d6+6",     "4d6+12",    "0",     "3d6",   "3d6",    "12", "Horse",
  "3d6+6",  "3d6+20",    "3d6+6",     "5d6",   "7d6",   "3d6",    "6/40", "Hound",   
  "3d6",    "3d6",       "2d6+6",     "2d6+6", "3d6",   "3d6",    "8", "Human",
  "5d6+12", "3d6",       "5d6+24",    "1d6+12","6d6",   "3d6+3",  "7/11", "HuntingHorror",
  "1d6+1",  "3d6",       "1d6",       "0",     "1d6+6", "2d6+6",  "15", "IndianDog",
  "8d6",    "5d6",       "10d6",      "3d6",   "4d6",   "3d6+6",  "6", "LengSpider",
  "2d6+12", "3d6",       "3d6+6",     "0",     "2d6+6", "2d6+12", "10", "Lion",
  "3d6+30", "8d6",       "2d40",      "4d6+6", "4d6",   "3d6",    "7/3", "Lloigor",
  "3d6",    "3d6",       "3d6",       "2d6+6", "2d6+6", "4d6",    "7/9", "Mi-Go",
  "3d6+6",  "3d6",       "2d6+8",     "0",     "3d6",   "2d6+12", "12", "MountainLion",
  "6d6",    "9d3",       "3d6",       "3d6",   "1d6+12","2d6",    "6", "Mummy",
  "3d6+12", "2d6+6",     "5d6",       "0",     "3d6",   "2d6+6",  "6", "Python",
  "1d3",    "2d6",       "1",         "3d6",   "2d6",   "4d6+4",  "9", "RatThing",
  "6d6+20", "3d6+6",     "6d6+20",    "0",     "3d6",   "2d6",    "15", "Rhino",
  "3d6",    "2d6+6",     "3d6+6",     "3d6",   "3d6",   "2d6",    "8", "SandDweller",
  "3d6",    "3d6",       "3d6",       "3d6+6", "2d6+6", "2d6+6",  "8", "SerpentPeople",
  "4d6",    "3d6+6",     "4d6+6",     "5d6",   "2d6+12","3d6+6",  "7", "ServitorOuterGod",
  "3d6",    "6d6",       "2d6+6",     "2d6+6", "3d6",   "1d6",    "5", "ServantOfGlaaki", 
  "1d3",    "1d3",       "1",         "3d6+6", "5d6",   "2d6+24", "4/40", "ShaggaiInsect",
  "2d6+12", "3d6+6",     "2d6+12",    "2d6",   "3d6",   "3d6",    "7", "Shambler",     
  "18d6",   "12d6",      "24d6",      "2d6",   "3d6",   "1d6",    "10", "Shoggoth",
  "3d6",    "0",         "3d6",       "3d6",   "1",     "3d6",    "7", "Skeleton",
  "6d6",    "2d6+6",     "6d6",       "0",     "3d6",   "2d6+12", "4/10", "Squid",
  "20d6",   "15d6",      "30d6",      "6d6",   "6d6",   "3d6",    "20", "StarSpawn",
  "4d6+12", "2d6+6",     "4d6+12",    "3d6",   "1d6+12","1d6+6",  "6/9", "StarVampire",
  "3d6+12", "3d6",       "3d6+6",     "0",     "3d6",   "2d6+12", "10", "Tiger",
  "1d6",    "3d6+6",     "1d6",       "0",     "3d6",   "4d6",    "1d10+3", "Ubbo-SathlaSpawn1",
  "6d10+6", "3d6+6",     "6d10+10",   "0",     "3d6",   "4d6",    "1d10+3", "Ubbo-SathlaSpawn6",
  "6d6",    "2d6+6",     "3d6",       "3d6",   "2d6+6", "3d6",    "race+2", "Vampire",
  "6d6",    "2d6+6",     "7d3",       "1d4+2", "2d6+6", "2d6+6",  "13", "Werewolf",
  "2d6+6",  "3d6",       "2d6+1",     "0",     "3d6",   "2d6+6",  "12", "Wolf",
  "6d6+30", "3d6+24",    "4d6+30",    "2d6",   "3d6",   "4d6",    "8", "Xiclotan",
  "7d3",    "7d3",       "3d6",       "0",     "1",     "2d6",    "6", "Zombie",
  "","","","","","","",""
  };

int roll(int diemax)
{
  return((rand() % diemax)+1);
}         

void cleanup(char *out, char *in)
{
  while ((*out++ = my_tolower(*in++)) != 0)
  {
    if (*--out != 32) out++;
  }
}              

int make_roll(char* in)
{
  char san[10];
  int a,b,c,d;
              
  cleanup(san, in);
  
  d=sscanf(san,"%dd%d+%d",&a,&b,&c);
  if (d<3) c=0; /* note: this can not be replaced with a case structure - note the */
  if (d<2) b=1; /* less than signs... */
  if (d<1) a=0;
  
  for (d=0; d<a; d++)
  {
    c += roll(b);
  }
  return (c);
}

void make_monster(struct monster m)
{           
   int str,con,siz,inte,pow,dex,hp;
   char *move;
  
   str = make_roll(m.str);
   con = make_roll(m.con);
   siz = make_roll(m.siz);
   inte = make_roll(m.inte);
   pow = make_roll(m.pow);
   dex = make_roll(m.dex);
   move = m.move;
   hp = (con + siz)/2;
   
   printf("%-12s: str %2d  con %2d  siz %2d  int %2d  pow %2d  dex %2d  move %s  hp %2d\n", m.name,str,con,siz,inte,pow,dex,move,hp);
   damage_bonus(str + siz);
}

void str_lower(char* out, char* in)
{
  while(*in != 0)
  {
    *out++=my_tolower(*in++);
  }
  *out = 0;
}

int main(int argc, char *argv[])
{                
  time_t tmt;              
  int i;                   
  int j;
  char in_name[32];
  char out_name[32];

  time(&tmt);                       /* randomise the random function */
  srand(tmt);
                                             
  banner();            
              
  if (argc > 1)
  {
    for (i=1; i<argc; i++)
    {  
      int made;

      str_lower(in_name, argv[i]);
      made = 0;
      
      /* try to match in array now */    
      j = 0;
      while (*monster_array[j].name != 0 && made==0)
      {
        str_lower(out_name, monster_array[j].name);
        if(strncmp(in_name,out_name,strlen(in_name))==0)
        {
          make_monster(monster_array[j]);
          made=1;
        }
        j++;
      }   
      if (made==0)
      {
        printf("Monster '%s' not known\n",argv[i]);
      }
    }
  }
  else
  {
    printf("Usage %s <monster name> [<monster name>...]\n",argv[0]);
    printf("Known monsters are:\n");
    j = 0;
    i = 0;
    while (*monster_array[j].name != 0)
    {   
      printf("%-18s ",monster_array[j++].name);
      if (++i % 4 == 0)
      {
        printf("\n");
      }
    }  
    if (i % 4 != 0) printf("\n");
  }
  return 0;
}
